// StartPriority.cpp : Defines the entry point for the console application.
//


//Grzegorz Niemirowski
//www.grzegorz.net
//grzegorz@grzegorz.net

#include "stdafx.h"
#include "windows.h"

void printhelp();

int main(int argc, char * argv[])
{
	STARTUPINFO a;
	PROCESS_INFORMATION b;
	char prog[1024];
	char prio;
	char priobuf[1024];
	int i;
	prog[0]=NULL;
	if (argc<2) {
		printhelp();
	}
	else {
		if (argc==2) {
			strcpy(priobuf,*(argv+1));
			prio=priobuf[0];
			if (prio=='/') {
				printhelp();
				return 0;
			}
			else {
				prio=0;
				i=1;
			}
		}
		else {
			strcpy(priobuf,(*(argv+1)+1));
			prio=priobuf[0];
			i=2;
		}
		for (i; i<argc; i++) {
			strcat (prog,*(argv+i));
			strcat (prog," ");
		}
		prog[strlen(prog)-1]=NULL;
		a.lpReserved=NULL;
		a.lpDesktop =NULL;
		a.lpTitle =NULL;
		a.cbReserved2 =0;
		a.lpReserved2 =NULL;
		a.cb =sizeof a;
		switch(prio)
		{
		case 73:
			CreateProcess(NULL,prog,NULL,NULL,FALSE,IDLE_PRIORITY_CLASS,NULL,NULL,&a,&b);
			break;
		case 76:
			CreateProcess(NULL,prog,NULL,NULL,FALSE,IDLE_PRIORITY_CLASS,NULL,NULL,&a,&b);
			break;
		case 72:
			CreateProcess(NULL,prog,NULL,NULL,FALSE,HIGH_PRIORITY_CLASS,NULL,NULL,&a,&b);
			break;
		case 82:
			CreateProcess(NULL,prog,NULL,NULL,FALSE,REALTIME_PRIORITY_CLASS,NULL,NULL,&a,&b);
			break;
		default:
			CreateProcess(NULL,prog,NULL,NULL,FALSE,NORMAL_PRIORITY_CLASS,NULL,NULL,&a,&b);
			break;
		}
		
	}
	return 0;
}

void printhelp() {
	printf("StartPriority 1.1 Copyright(C) Grzegorz Niemirowski grzegorz@grzegorz.net\n");
	printf("Usage:\n");
	printf("StartPriority [priority], path to an application [arguments]\n");
	printf("Priorites switches:\n");
	printf("/LOW\n");
	printf("/IDLE\n");
	printf("/NORMAL\n");
	printf("/HIGH\n");
	printf("/REALTIME\n");
	printf("/ABOVENORMAL\n");
	printf("/BELOWNORMAL\n");
	printf("First letters of priorities switches are also accepted.\n");
	printf("Examples:\nStartPriority /L notepad.exe file.txt\n");
	printf("StartPriority calc.exe\n");
	printf("StartPriority paint.exe pict.bmp\n");
	printf("StartPriority /HIGH paint.exe\n");
}